import java.awt.Color;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import javax.swing.Action;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

class Gui extends JFrame {

    private JPanel inhalt = null;

    private JButton knopf = null;

    private JLabel label = null;

    private JTextField textFeld = null;

    private JScrollPane scrollAusschnitt = null;

    private JScrollPane scrollAusschnitt2 = null;
    
    private JScrollPane scrollAusschnitt3 = null;

    private JTable tabelle = null;
    
    private JTable tabelle2 = null;

    private TableModel modell = null;

    public static void main(String[] args) {
        Gui gui = new Gui("GUI", 600, 600);

        gui.setVisible(true);
    }

    public Gui(String titel, int breite, int hoehe) {
        super(titel);
        init(breite, hoehe);
    }

    protected void aufraeumen() {
        System.out.println("Aufrumen!");
    }

    private void init(int breite, int hoehe) {
        setJMenuBar(machMenueLeiste());
        setContentPane(getJContentPane());

        setSize(breite, hoehe);

        Dimension screenDim = Toolkit.getDefaultToolkit().getScreenSize();
        Rectangle winDim = getBounds();
        setLocation((screenDim.width - winDim.width) / 2, (screenDim.height - winDim.height) / 2);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                aufraeumen();
                System.exit(0);
            }
        });
    }

    private JPanel getJContentPane() {
        if (inhalt == null) {
            inhalt = new JPanel();
            inhalt.setLayout(null);
            inhalt.add(machLabel());
            inhalt.add(machKnopf());
            inhalt.add(machTextfeld());
            inhalt.add(machTabelle());
            inhalt.add(machTabelleMitModell());
            inhalt.add(machTabelleMitGleichemModell());
        }
        return inhalt;
    }

    private JLabel machLabel() {
        if (label == null) {
            label = new JLabel("Ich bin ein Label!");
            label.setBounds(10, 10, 100, 50);
        }
        return label;
    }

    private JButton machKnopf() {
        if (knopf == null) {
            knopf = new JButton("Drck mich!");
            knopf.setBounds(200, 10, 200, 50);
            knopf.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    System.out.println("Knopf wurde gedrckt!");
                    modell.setValueAt(textFeld.getText(), 1, 0);
                }
            });

            // XXX soll noch entwickelt werden
            knopf.addPropertyChangeListener(new PropertyChangeListener() {

                public void propertyChange(PropertyChangeEvent evt) {
                    String name = evt.getPropertyName();
                    System.out.println("Property " + name + " wurde gendert!");
                }

            });

        }
        return knopf;
    }

    private JTextField machTextfeld() {
        if (textFeld == null) {
            textFeld = new JTextField();
            textFeld.setBounds(200, 200, 200, 50);
            textFeld.setText("Werner");

            textFeld.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    System.out.println("Text eingegeben: " + textFeld.getText());
                }

            });

            // XXX soll noch entwickelt werden
            textFeld.addFocusListener(new FocusListener() {

                public void focusGained(FocusEvent e) {
                    System.out.println("Focus is da");
                }

                public void focusLost(FocusEvent e) {
                    System.out.println("Focus is weg");
                }

            });
        }
        return textFeld;
    }

    private JScrollPane machTabelle() {
        if (scrollAusschnitt == null) {
            String[] spaltenNamen = { "Name", "Alter" };
            Object[][] daten = { { "Olli", new Integer(34) }, { "Kuno", new Integer(12) },
                    { "Herta", new Integer(40) }, { "Frieda", new Integer(22) },
                    { "Dieter", new Integer(47) }, { "Walter", new Integer(76) },
                    { "Doren", new Integer(15) }, { "Tino", new Integer(7) },
                    { "Edeltraut", new Integer(40) } };
            JTable tab = new JTable(daten, spaltenNamen);
            scrollAusschnitt = new JScrollPane(tab);
            scrollAusschnitt.setBounds(50, 300, 200, 100);
            // scrollAusschnitt.setPreferredScrollableViewportSize(new Dimension(500,
            // 70));
        }
        return scrollAusschnitt;
    }

    private JScrollPane machTabelleMitModell() {
        if (scrollAusschnitt2 == null) {
            if (modell == null) modell = new UnserModell();
            tabelle = new JTable(modell);
            scrollAusschnitt2 = new JScrollPane(tabelle);
            scrollAusschnitt2.setBounds(350, 300, 200, 100);
            // scrollAusschnitt.setPreferredScrollableViewportSize(new Dimension(500,
            // 70));
        }
        return scrollAusschnitt2;
    }

    private JScrollPane machTabelleMitGleichemModell() {
        if (scrollAusschnitt3 == null) {
            if (modell == null) modell = new UnserModell();
            tabelle2 = new JTable(modell);
            scrollAusschnitt3 = new JScrollPane(tabelle2);
            scrollAusschnitt3.setBounds(225, 425, 200, 100);
            // scrollAusschnitt.setPreferredScrollableViewportSize(new Dimension(500,
            // 70));
        }
        return scrollAusschnitt3;
    }

    private JMenuBar machMenueLeiste() {

        JMenuItem menueEintragOeffnen = new JMenuItem("ffnen");
        menueEintragOeffnen.setAction(new Action() {

            public Object getValue(String key) {
                // TODO Auto-generated method stub
                return null;
            }

            public void putValue(String key, Object value) {
                // TODO Auto-generated method stub
                
            }

            public void setEnabled(boolean b) {
                // TODO Auto-generated method stub
                
            }

            public boolean isEnabled() {
                // TODO Auto-generated method stub
                return false;
            }

            public void addPropertyChangeListener(PropertyChangeListener listener) {
                // TODO Auto-generated method stub
                
            }

            public void removePropertyChangeListener(PropertyChangeListener listener) {
                // TODO Auto-generated method stub
                
            }

            public void actionPerformed(ActionEvent e) {
                // TODO Auto-generated method stub
                
            }
            
        });
        menueEintragOeffnen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("ffnen");
                // XXX soll noch entwickelt werden
                knopf.setForeground(new Color(0xFF00FF));
            }

        });

        JMenuItem menueEintragSpeichern = new JMenuItem("Speichern");
        menueEintragSpeichern.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Speichern");
            }

        });

        JMenuItem menueEintragEnde = new JMenuItem("Ende");
        menueEintragEnde.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Ende");
                System.exit(0);
            }

        });

        JMenu menueDatei = new JMenu("Datei");
        menueDatei.add(menueEintragOeffnen);
        menueDatei.add(menueEintragSpeichern);
        menueDatei.add(menueEintragEnde);

        JMenuItem menueEintragKopieren = new JMenuItem("Kopieren");
        menueEintragKopieren.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Kopieren");
            }

        });

        JMenuItem menueEintragEinfuegen = new JMenuItem("Einfgen");
        menueEintragEinfuegen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Einfgen");
                tabelle.setModel(new KomischesModell());
            }

        });

        JMenuItem menueEintragLoeschen = new JMenuItem("Lschen");
        menueEintragLoeschen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                System.out.println("Lschen");
                tabelle.setModel(new UnserModell2());
            }

        });

        JMenu menueBearbeiten = new JMenu("Bearbeiten");
        menueBearbeiten.add(menueEintragKopieren);
        menueBearbeiten.add(menueEintragEinfuegen);
        menueBearbeiten.add(menueEintragLoeschen);

        JMenuBar menueLeiste = new JMenuBar();
        menueLeiste.add(menueDatei);
        menueLeiste.add(menueBearbeiten);

        return menueLeiste;
    }

    private static class UnserModell extends AbstractTableModel {
        String[] spaltenNamen = { "Name", "Alter" };

        Object[][] daten = { { "Olli", new Integer(34) }, { "Kuno", new Integer(12) },
                { "Herta", new Integer(40) }, { "Frieda", new Integer(22) },
                { "Dieter", new Integer(47) }, { "Walter", new Integer(76) },
                { "Doren", new Integer(15) }, { "Tino", new Integer(7) },
                { "Edeltraut", new Integer(40) } };

        public String getColumnName(int col) {
            return spaltenNamen[col];
        }

        public int getRowCount() {
            return daten.length;
        }

        public int getColumnCount() {
            return spaltenNamen.length;
        }

        public Object getValueAt(int row, int col) {
            return daten[row][col];
        }

        public boolean isCellEditable(int row, int col) {
            return true;
        }

        public void setValueAt(Object value, int row, int col) {
            daten[row][col] = value;
            fireTableCellUpdated(row, col);
        }
    }

    private static class UnserModell2 extends AbstractTableModel {
        String[] spaltenNamen = { "Name", "Alter" };

        Object[][] daten = { { "Olli", new Integer(34) }, { "Kuno", new Integer(12) },
                { "Doren", new Integer(15) }, { "Tino", new Integer(7) },
                { "Dieter", new Integer(47) }, { "Walter", new Integer(76) },
                { "Herta", new Integer(40) }, { "Frieda", new Integer(22) },
                { "Edeltraut", new Integer(40) } };

        public String getColumnName(int col) {
            return spaltenNamen[col];
        }

        public int getRowCount() {
            return daten.length;
        }

        public int getColumnCount() {
            return spaltenNamen.length;
        }

        public Object getValueAt(int row, int col) {
            return daten[row][col];
        }

        public boolean isCellEditable(int row, int col) {
            return true;
        }

        public void setValueAt(Object value, int row, int col) {
            daten[row][col] = value;
            fireTableCellUpdated(row, col);
        }
    }

    private static class KomischesModell extends AbstractTableModel {

        public int getRowCount() {
            return 1000000;
        }

        public int getColumnCount() {
            // TODO Auto-generated method stub
            return 2;
        }

        public Object getValueAt(int rowIndex, int columnIndex) {
            if (columnIndex == 0) {
                return "Name"+rowIndex;
            } else {
                return new Integer(rowIndex);
            }
        }
        
    }
}
